const String _errCode = "errCode";
const String _errStr = "errStr";

typedef BasePangolinResponse _PangolinResponseInvoker(Map argument);

Map<String, _PangolinResponseInvoker> _nameAndResponseMapper = {
  "onRewardResponse": (Map argument) => onRewardResponse.fromMap(argument),
};

class BasePangolinResponse {
  final int errCode;
  final String errStr;

  bool get isSuccessful => errCode == 0;

  BasePangolinResponse._(this.errCode, this.errStr);

  /// create response from response pool
  factory BasePangolinResponse.create(String name, Map argument) {
    if (_nameAndResponseMapper != null) {
      if (_nameAndResponseMapper.containsKey(name)) {
        if (_nameAndResponseMapper[name] != null) {
          var res = _nameAndResponseMapper[name]!(argument);
          return res;
        }
      }
    }
    return onRewardResponse.fromMap(argument);
  }
}

class onRewardResponse extends BasePangolinResponse {
  final bool rewardVerify;
  final int rewardAmount;
  final String rewardName;

  onRewardResponse.fromMap(Map map)
      : rewardVerify = map["rewardVerify"],
        rewardAmount = map["rewardAmount"],
        rewardName = map["rewardName"],
        super._(map[_errCode], map[_errStr]);
}
